import { NgModule } from '@angular/core'
import { CommonModule } from '@angular/common'

import { MatButtonModule } from '@angular/material/button'
import { MatFormFieldModule } from '@angular/material/form-field'
import { MatIconModule } from '@angular/material/icon'
import { MatSelectModule } from '@angular/material/select'
import { MatSlideToggleModule } from '@angular/material/slide-toggle'

import { FlexLayoutModule } from 'ngx-flexible-layout'

// Use Plotly Via Window Module
// See https://github.com/plotly/angular-plotly.js/blob/master/README.md#plotly-via-window-module
import { PlotlyViaWindowModule } from 'angular-plotly.js'

//import * as PlotlyJS from 'plotly.js-dist-min'
//import { PlotlyModule } from 'angular-plotly.js'
//PlotlyModule.plotlyjs = PlotlyJS

import { InfoPlotComponent }  from './plot.component'


@NgModule({
    imports: [
        CommonModule,
        MatButtonModule,
        MatFormFieldModule,
        MatIconModule,
        MatSelectModule,
        MatSlideToggleModule,

        FlexLayoutModule,

        //PlotlyModule,
        PlotlyViaWindowModule,
    ],
    declarations: [
        InfoPlotComponent,
    ],
    exports: [
        InfoPlotComponent,
    ]
})
export class InfoPlotModule { }
